# Copyright (c) 2019 congvm
# 
# This software is released under the MIT License.
# https://opensource.org/licenses/MIT

from flask import Flask
from flask import render_template, request
import json
import traceback
from thrift4DL.client import VisionClient
APP_NAME = 'RESTful-Thrift4DL'

def create_app(host, port):
    app = Flask(APP_NAME)
    
    @app.route('/v1/predict/', methods=['POST'])
    def predict():
        pred_result = {"error_code": -1, "error_message": "Failed", "content": ""}
        try:
            client = VisionClient(host=host, port=port)
            pred_result = client.predict(request.data.decode('utf-8'))
        except:
            print(traceback.format_exc())
        return json.dumps(pred_result)
    return app


